{
 "cells": [
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# HW 3\n",
    "\n",
    "In this HW, we are going to back-test strategies of forecasting FX returns on a rolling basis.\n",
    "\n",
    "We'll back-test two strategies, one based on Model Selection Method A, and the other based on Method B.\t\t\t\t\t\n",
    "\n",
    "Deliverables: \n",
    "\n",
    "- A. the program coding. \n",
    "\n",
    "- B. performance summaries for the two strategies.\n",
    "\n",
    "By: Chengyi (Jeff) Chen"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 1,
   "metadata": {},
   "outputs": [
    {
     "name": "stderr",
     "output_type": "stream",
     "text": [
      "/opt/anaconda3/envs/ml/lib/python3.7/site-packages/statsmodels/tools/_testing.py:19: FutureWarning: pandas.util.testing is deprecated. Use the functions in the public API at pandas.testing instead.\n",
      "  import pandas.util.testing as tm\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 1;\n",
       "                var nbb_unformatted_code = \"%load_ext autotime\\n%load_ext nb_black\\n%matplotlib inline\\n\\nimport matplotlib.pyplot as plt\\n\\nplt.rcParams[\\\"figure.dpi\\\"] = 300\\nplt.rcParams[\\\"figure.figsize\\\"] = (16, 12)\\n\\nimport pandas as pd\\nimport numpy as np\\nimport cvxpy as cp\\nimport scipy as sp\\nfrom sklearn.metrics import mean_squared_error\\nfrom statsmodels.tsa.arima_model import ARIMA\\nfrom datetime import datetime, timedelta\\nimport warnings\\n\\nwarnings.simplefilter(\\\"ignore\\\")\";\n",
       "                var nbb_formatted_code = \"%load_ext autotime\\n%load_ext nb_black\\n%matplotlib inline\\n\\nimport matplotlib.pyplot as plt\\n\\nplt.rcParams[\\\"figure.dpi\\\"] = 300\\nplt.rcParams[\\\"figure.figsize\\\"] = (16, 12)\\n\\nimport pandas as pd\\nimport numpy as np\\nimport cvxpy as cp\\nimport scipy as sp\\nfrom sklearn.metrics import mean_squared_error\\nfrom statsmodels.tsa.arima_model import ARIMA\\nfrom datetime import datetime, timedelta\\nimport warnings\\n\\nwarnings.simplefilter(\\\"ignore\\\")\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "%load_ext autotime\n",
    "%load_ext nb_black\n",
    "%matplotlib inline\n",
    "\n",
    "import matplotlib.pyplot as plt\n",
    "\n",
    "plt.rcParams[\"figure.dpi\"] = 300\n",
    "plt.rcParams[\"figure.figsize\"] = (16, 12)\n",
    "\n",
    "import pandas as pd\n",
    "import numpy as np\n",
    "import cvxpy as cp\n",
    "import scipy as sp\n",
    "from sklearn.metrics import mean_squared_error\n",
    "from statsmodels.tsa.arima_model import ARIMA\n",
    "from datetime import datetime, timedelta\n",
    "import warnings\n",
    "\n",
    "warnings.simplefilter(\"ignore\")"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 2,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>EURUSD</th>\n",
       "      <th>GBPUSD</th>\n",
       "      <th>JPYUSD</th>\n",
       "      <th>AUDUSD</th>\n",
       "      <th>CADUSD</th>\n",
       "      <th>NOKUSD</th>\n",
       "      <th>CHFUSD</th>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>date</th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>1994-04-29</th>\n",
       "      <td>1.1840</td>\n",
       "      <td>1.5185</td>\n",
       "      <td>0.009833</td>\n",
       "      <td>0.7155</td>\n",
       "      <td>0.7231</td>\n",
       "      <td>0.1395</td>\n",
       "      <td>0.7125</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>1994-05-31</th>\n",
       "      <td>1.1909</td>\n",
       "      <td>1.5113</td>\n",
       "      <td>0.009544</td>\n",
       "      <td>0.7371</td>\n",
       "      <td>0.7225</td>\n",
       "      <td>0.1400</td>\n",
       "      <td>0.7130</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>1994-06-30</th>\n",
       "      <td>1.2238</td>\n",
       "      <td>1.5443</td>\n",
       "      <td>0.010158</td>\n",
       "      <td>0.7285</td>\n",
       "      <td>0.7224</td>\n",
       "      <td>0.1444</td>\n",
       "      <td>0.7499</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>1994-07-29</th>\n",
       "      <td>1.2261</td>\n",
       "      <td>1.5440</td>\n",
       "      <td>0.009985</td>\n",
       "      <td>0.7395</td>\n",
       "      <td>0.7211</td>\n",
       "      <td>0.1448</td>\n",
       "      <td>0.7463</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>1994-08-31</th>\n",
       "      <td>1.2341</td>\n",
       "      <td>1.5340</td>\n",
       "      <td>0.009995</td>\n",
       "      <td>0.7429</td>\n",
       "      <td>0.7310</td>\n",
       "      <td>0.1442</td>\n",
       "      <td>0.7508</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "</div>"
      ],
      "text/plain": [
       "            EURUSD  GBPUSD    JPYUSD  AUDUSD  CADUSD  NOKUSD  CHFUSD\n",
       "date                                                                \n",
       "1994-04-29  1.1840  1.5185  0.009833  0.7155  0.7231  0.1395  0.7125\n",
       "1994-05-31  1.1909  1.5113  0.009544  0.7371  0.7225  0.1400  0.7130\n",
       "1994-06-30  1.2238  1.5443  0.010158  0.7285  0.7224  0.1444  0.7499\n",
       "1994-07-29  1.2261  1.5440  0.009985  0.7395  0.7211  0.1448  0.7463\n",
       "1994-08-31  1.2341  1.5340  0.009995  0.7429  0.7310  0.1442  0.7508"
      ]
     },
     "execution_count": 2,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "time: 154 ms\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 2;\n",
       "                var nbb_unformatted_code = \"raw_data = pd.read_excel(\\\"./data/HW3_20201112.xlsx\\\", sheet_name=1)\\navailable_currencies = raw_data.columns[::3]\\ndata = raw_data.iloc[1:, list(range(1, len(raw_data.columns), 3))].astype(float)\\ndata.columns = raw_data.iloc[0, list(range(1, len(raw_data.columns), 3))].values\\ndata.index = pd.to_datetime(raw_data.iloc[1:, 0])\\ndata.index.name = \\\"date\\\"\\ndata.index.freq = \\\"-1BM\\\"\\ndata = data.sort_index()\\ndata.head()\";\n",
       "                var nbb_formatted_code = \"raw_data = pd.read_excel(\\\"./data/HW3_20201112.xlsx\\\", sheet_name=1)\\navailable_currencies = raw_data.columns[::3]\\ndata = raw_data.iloc[1:, list(range(1, len(raw_data.columns), 3))].astype(float)\\ndata.columns = raw_data.iloc[0, list(range(1, len(raw_data.columns), 3))].values\\ndata.index = pd.to_datetime(raw_data.iloc[1:, 0])\\ndata.index.name = \\\"date\\\"\\ndata.index.freq = \\\"-1BM\\\"\\ndata = data.sort_index()\\ndata.head()\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "raw_data = pd.read_excel(\"./data/HW3_20201112.xlsx\", sheet_name=1)\n",
    "available_currencies = raw_data.columns[::3]\n",
    "data = raw_data.iloc[1:, list(range(1, len(raw_data.columns), 3))].astype(float)\n",
    "data.columns = raw_data.iloc[0, list(range(1, len(raw_data.columns), 3))].values\n",
    "data.index = pd.to_datetime(raw_data.iloc[1:, 0])\n",
    "data.index.name = \"date\"\n",
    "data.index.freq = \"-1BM\"\n",
    "data = data.sort_index()\n",
    "data.head()"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "## Step 1:\t\n",
    "\n",
    "Transform currency prices to monthly returns"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 3,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>EURUSD</th>\n",
       "      <th>GBPUSD</th>\n",
       "      <th>JPYUSD</th>\n",
       "      <th>AUDUSD</th>\n",
       "      <th>CADUSD</th>\n",
       "      <th>NOKUSD</th>\n",
       "      <th>CHFUSD</th>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>date</th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>1994-05-31</th>\n",
       "      <td>0.005828</td>\n",
       "      <td>-0.004742</td>\n",
       "      <td>-0.029391</td>\n",
       "      <td>0.030189</td>\n",
       "      <td>-0.000830</td>\n",
       "      <td>0.003584</td>\n",
       "      <td>0.000702</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>1994-06-30</th>\n",
       "      <td>0.027626</td>\n",
       "      <td>0.021836</td>\n",
       "      <td>0.064334</td>\n",
       "      <td>-0.011667</td>\n",
       "      <td>-0.000138</td>\n",
       "      <td>0.031429</td>\n",
       "      <td>0.051753</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>1994-07-29</th>\n",
       "      <td>0.001879</td>\n",
       "      <td>-0.000194</td>\n",
       "      <td>-0.017031</td>\n",
       "      <td>0.015100</td>\n",
       "      <td>-0.001800</td>\n",
       "      <td>0.002770</td>\n",
       "      <td>-0.004801</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>1994-08-31</th>\n",
       "      <td>0.006525</td>\n",
       "      <td>-0.006477</td>\n",
       "      <td>0.001002</td>\n",
       "      <td>0.004598</td>\n",
       "      <td>0.013729</td>\n",
       "      <td>-0.004144</td>\n",
       "      <td>0.006030</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>1994-09-30</th>\n",
       "      <td>0.017827</td>\n",
       "      <td>0.028357</td>\n",
       "      <td>0.009105</td>\n",
       "      <td>-0.003634</td>\n",
       "      <td>0.018605</td>\n",
       "      <td>0.022191</td>\n",
       "      <td>0.034497</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "</div>"
      ],
      "text/plain": [
       "              EURUSD    GBPUSD    JPYUSD    AUDUSD    CADUSD    NOKUSD  \\\n",
       "date                                                                     \n",
       "1994-05-31  0.005828 -0.004742 -0.029391  0.030189 -0.000830  0.003584   \n",
       "1994-06-30  0.027626  0.021836  0.064334 -0.011667 -0.000138  0.031429   \n",
       "1994-07-29  0.001879 -0.000194 -0.017031  0.015100 -0.001800  0.002770   \n",
       "1994-08-31  0.006525 -0.006477  0.001002  0.004598  0.013729 -0.004144   \n",
       "1994-09-30  0.017827  0.028357  0.009105 -0.003634  0.018605  0.022191   \n",
       "\n",
       "              CHFUSD  \n",
       "date                  \n",
       "1994-05-31  0.000702  \n",
       "1994-06-30  0.051753  \n",
       "1994-07-29 -0.004801  \n",
       "1994-08-31  0.006030  \n",
       "1994-09-30  0.034497  "
      ]
     },
     "execution_count": 3,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "time: 24.9 ms\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 3;\n",
       "                var nbb_unformatted_code = \"monthly_returns = data.pct_change(1).iloc[1:]\\nmonthly_returns.head()\";\n",
       "                var nbb_formatted_code = \"monthly_returns = data.pct_change(1).iloc[1:]\\nmonthly_returns.head()\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "monthly_returns = data.pct_change(1).iloc[1:]\n",
    "monthly_returns.head()"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "## Step 2:\t\n",
    "\n",
    "Starting from 12/31/1999, at each month-end date, we'll forecast next-month returns for the seven currencies separately using one of two different model selection methods:\n",
    "\n",
    "Two models:\n",
    "\n",
    "1. AR(1)\n",
    "\n",
    "2. MA(1)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Model Selection Method A (In-Sample):\t\t\t\n",
    "\n",
    "At the time point t, calibrate/estimate the two models based on the past 24 monthly return observations (current observation at t included).\n",
    "\n",
    "Calculate the AICs for the two estimated models for those 24 obsevations, and choose the one with lower AIC.\t\t\t\n",
    "\n",
    "Please note that AIC and mean squared error (MSE) are equivalent for comparing the two pre-assigned models. (So if you are not familiar with AIC, try use MSE instead).\n",
    "\n",
    "Forecast the next period return at time (t+1) using the selected model. "
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 4,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "time: 473 µs\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 4;\n",
       "                var nbb_unformatted_code = \"start_date = \\\"1999-12-31\\\"\";\n",
       "                var nbb_formatted_code = \"start_date = \\\"1999-12-31\\\"\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "start_date = \"1999-12-31\""
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 5,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>EURUSD</th>\n",
       "      <th>GBPUSD</th>\n",
       "      <th>JPYUSD</th>\n",
       "      <th>AUDUSD</th>\n",
       "      <th>CADUSD</th>\n",
       "      <th>NOKUSD</th>\n",
       "      <th>CHFUSD</th>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>date</th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>2000-01-31</th>\n",
       "      <td>-0.003131</td>\n",
       "      <td>-0.001858</td>\n",
       "      <td>0.014124</td>\n",
       "      <td>-0.000595</td>\n",
       "      <td>-0.002344</td>\n",
       "      <td>0.011939</td>\n",
       "      <td>-0.003192</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-02-29</th>\n",
       "      <td>-0.006137</td>\n",
       "      <td>-0.000819</td>\n",
       "      <td>0.018341</td>\n",
       "      <td>-0.000382</td>\n",
       "      <td>0.000340</td>\n",
       "      <td>0.012523</td>\n",
       "      <td>-0.007582</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-03-31</th>\n",
       "      <td>-0.004628</td>\n",
       "      <td>0.009065</td>\n",
       "      <td>0.012377</td>\n",
       "      <td>-0.002184</td>\n",
       "      <td>-0.000579</td>\n",
       "      <td>0.002050</td>\n",
       "      <td>-0.005109</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-04-28</th>\n",
       "      <td>-0.004501</td>\n",
       "      <td>-0.001630</td>\n",
       "      <td>-0.000457</td>\n",
       "      <td>-0.002368</td>\n",
       "      <td>-0.000798</td>\n",
       "      <td>-0.000776</td>\n",
       "      <td>-0.002774</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-05-31</th>\n",
       "      <td>-0.011437</td>\n",
       "      <td>0.007824</td>\n",
       "      <td>0.027002</td>\n",
       "      <td>-0.002033</td>\n",
       "      <td>0.000620</td>\n",
       "      <td>0.007167</td>\n",
       "      <td>-0.008398</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>...</th>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2018-11-30</th>\n",
       "      <td>-0.003151</td>\n",
       "      <td>0.010656</td>\n",
       "      <td>0.001052</td>\n",
       "      <td>-0.005594</td>\n",
       "      <td>-0.001367</td>\n",
       "      <td>0.002645</td>\n",
       "      <td>0.000012</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2018-12-31</th>\n",
       "      <td>0.002632</td>\n",
       "      <td>0.002070</td>\n",
       "      <td>0.001336</td>\n",
       "      <td>-0.000985</td>\n",
       "      <td>-0.000446</td>\n",
       "      <td>0.001262</td>\n",
       "      <td>0.000492</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2019-01-31</th>\n",
       "      <td>0.005300</td>\n",
       "      <td>0.001749</td>\n",
       "      <td>0.001517</td>\n",
       "      <td>-0.000071</td>\n",
       "      <td>-0.004193</td>\n",
       "      <td>0.000369</td>\n",
       "      <td>0.001042</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2019-02-28</th>\n",
       "      <td>0.001467</td>\n",
       "      <td>-0.006201</td>\n",
       "      <td>0.001589</td>\n",
       "      <td>-0.007189</td>\n",
       "      <td>0.005521</td>\n",
       "      <td>0.000814</td>\n",
       "      <td>-0.000118</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2019-03-29</th>\n",
       "      <td>0.000857</td>\n",
       "      <td>0.000701</td>\n",
       "      <td>0.001366</td>\n",
       "      <td>0.000846</td>\n",
       "      <td>-0.000173</td>\n",
       "      <td>-0.000415</td>\n",
       "      <td>0.000416</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "<p>231 rows × 7 columns</p>\n",
       "</div>"
      ],
      "text/plain": [
       "              EURUSD    GBPUSD    JPYUSD    AUDUSD    CADUSD    NOKUSD  \\\n",
       "date                                                                     \n",
       "2000-01-31 -0.003131 -0.001858  0.014124 -0.000595 -0.002344  0.011939   \n",
       "2000-02-29 -0.006137 -0.000819  0.018341 -0.000382  0.000340  0.012523   \n",
       "2000-03-31 -0.004628  0.009065  0.012377 -0.002184 -0.000579  0.002050   \n",
       "2000-04-28 -0.004501 -0.001630 -0.000457 -0.002368 -0.000798 -0.000776   \n",
       "2000-05-31 -0.011437  0.007824  0.027002 -0.002033  0.000620  0.007167   \n",
       "...              ...       ...       ...       ...       ...       ...   \n",
       "2018-11-30 -0.003151  0.010656  0.001052 -0.005594 -0.001367  0.002645   \n",
       "2018-12-31  0.002632  0.002070  0.001336 -0.000985 -0.000446  0.001262   \n",
       "2019-01-31  0.005300  0.001749  0.001517 -0.000071 -0.004193  0.000369   \n",
       "2019-02-28  0.001467 -0.006201  0.001589 -0.007189  0.005521  0.000814   \n",
       "2019-03-29  0.000857  0.000701  0.001366  0.000846 -0.000173 -0.000415   \n",
       "\n",
       "              CHFUSD  \n",
       "date                  \n",
       "2000-01-31 -0.003192  \n",
       "2000-02-29 -0.007582  \n",
       "2000-03-31 -0.005109  \n",
       "2000-04-28 -0.002774  \n",
       "2000-05-31 -0.008398  \n",
       "...              ...  \n",
       "2018-11-30  0.000012  \n",
       "2018-12-31  0.000492  \n",
       "2019-01-31  0.001042  \n",
       "2019-02-28 -0.000118  \n",
       "2019-03-29  0.000416  \n",
       "\n",
       "[231 rows x 7 columns]"
      ]
     },
     "execution_count": 5,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "time: 1min 55s\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 5;\n",
       "                var nbb_unformatted_code = \"def model_selection_A(monthly_returns):\\n    \\\"\\\"\\\"Returns next period forecast using best model\\\"\\\"\\\"\\n    ar_1_model = ARIMA(monthly_returns, order=(1, 0, 0)).fit()  # AR(1)\\n    ma_1_model = ARIMA(monthly_returns, order=(0, 0, 1)).fit()  # MA(1)\\n\\n    # Select Best model based on AIC\\n    best_model = ar_1_model if ar_1_model.aic < ma_1_model.aic else ma_1_model\\n\\n    # Get forecast\\n    forecast, stderr, conf_int = best_model.forecast()\\n\\n    return forecast[0]\\n\\n\\nmodel_selection_A_predictions = (\\n    pd.concat(\\n        [\\n            monthly_returns[currency]\\n            .rolling(24, min_periods=24)\\n            .agg(model_selection_A)\\n            .loc[start_date:]\\n            for currency in monthly_returns.columns\\n        ],\\n        axis=1,\\n    )\\n    .shift(1)\\n    .iloc[1:]\\n)\\n\\nmodel_selection_A_predictions\";\n",
       "                var nbb_formatted_code = \"def model_selection_A(monthly_returns):\\n    \\\"\\\"\\\"Returns next period forecast using best model\\\"\\\"\\\"\\n    ar_1_model = ARIMA(monthly_returns, order=(1, 0, 0)).fit()  # AR(1)\\n    ma_1_model = ARIMA(monthly_returns, order=(0, 0, 1)).fit()  # MA(1)\\n\\n    # Select Best model based on AIC\\n    best_model = ar_1_model if ar_1_model.aic < ma_1_model.aic else ma_1_model\\n\\n    # Get forecast\\n    forecast, stderr, conf_int = best_model.forecast()\\n\\n    return forecast[0]\\n\\n\\nmodel_selection_A_predictions = (\\n    pd.concat(\\n        [\\n            monthly_returns[currency]\\n            .rolling(24, min_periods=24)\\n            .agg(model_selection_A)\\n            .loc[start_date:]\\n            for currency in monthly_returns.columns\\n        ],\\n        axis=1,\\n    )\\n    .shift(1)\\n    .iloc[1:]\\n)\\n\\nmodel_selection_A_predictions\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "def model_selection_A(monthly_returns):\n",
    "    \"\"\"Returns next period forecast using best model\"\"\"\n",
    "    ar_1_model = ARIMA(monthly_returns, order=(1, 0, 0)).fit()  # AR(1)\n",
    "    ma_1_model = ARIMA(monthly_returns, order=(0, 0, 1)).fit()  # MA(1)\n",
    "\n",
    "    # Select Best model based on AIC\n",
    "    best_model = ar_1_model if ar_1_model.aic < ma_1_model.aic else ma_1_model\n",
    "\n",
    "    # Get forecast\n",
    "    forecast, stderr, conf_int = best_model.forecast()\n",
    "\n",
    "    return forecast[0]\n",
    "\n",
    "\n",
    "model_selection_A_predictions = (\n",
    "    pd.concat(\n",
    "        [\n",
    "            monthly_returns[currency]\n",
    "            .rolling(24, min_periods=24)\n",
    "            .agg(model_selection_A)\n",
    "            .loc[start_date:]\n",
    "            for currency in monthly_returns.columns\n",
    "        ],\n",
    "        axis=1,\n",
    "    )\n",
    "    .shift(1)\n",
    "    .iloc[1:]\n",
    ")\n",
    "\n",
    "model_selection_A_predictions"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Model Selection Method B (Out-Sample):\t\t\t\n",
    "\n",
    "At the time point t, for each model, out-of-samplely forecast the returns for the past 12 months.\n",
    "\n",
    "- for each time point from t-11 to t, say for t-k where k=0,…,11, we'll estimate each model using the past 24 observations, i.e., observations at (t-k-24,…,t-k-1), then based on the estimated model to forecast returns at t-k. \n",
    "\n",
    "- Now, for AR(1) model, we have forecasts for t-11, t-10,…,t, the MSE can be calculated as the mean of (forecast - true return)^2. for MA(1) model, we have another vector of 12 forecasts, with corresponded 12 true returns, and we can calculate MSE. \n",
    "\n",
    "The model with lower MSE would be selected.\n",
    "\n",
    "And then we need to calibrate that model using the past 24 observations.\n",
    "\n",
    "Forecast the next period return at time (t+1)."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 6,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>EURUSD</th>\n",
       "      <th>GBPUSD</th>\n",
       "      <th>JPYUSD</th>\n",
       "      <th>AUDUSD</th>\n",
       "      <th>CADUSD</th>\n",
       "      <th>NOKUSD</th>\n",
       "      <th>CHFUSD</th>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>date</th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>2000-01-31</th>\n",
       "      <td>-0.003022</td>\n",
       "      <td>-0.005389</td>\n",
       "      <td>0.012898</td>\n",
       "      <td>-0.000065</td>\n",
       "      <td>-0.002057</td>\n",
       "      <td>-0.006123</td>\n",
       "      <td>-0.003192</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-02-29</th>\n",
       "      <td>-0.005529</td>\n",
       "      <td>-0.000007</td>\n",
       "      <td>0.014642</td>\n",
       "      <td>-0.000583</td>\n",
       "      <td>0.000287</td>\n",
       "      <td>0.009027</td>\n",
       "      <td>-0.007582</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-03-31</th>\n",
       "      <td>-0.004428</td>\n",
       "      <td>0.006833</td>\n",
       "      <td>0.010626</td>\n",
       "      <td>-0.002631</td>\n",
       "      <td>-0.000590</td>\n",
       "      <td>-0.002736</td>\n",
       "      <td>-0.005109</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-04-28</th>\n",
       "      <td>-0.004393</td>\n",
       "      <td>-0.005841</td>\n",
       "      <td>0.003849</td>\n",
       "      <td>-0.002691</td>\n",
       "      <td>-0.000777</td>\n",
       "      <td>-0.002713</td>\n",
       "      <td>-0.002774</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-05-31</th>\n",
       "      <td>-0.010242</td>\n",
       "      <td>0.007824</td>\n",
       "      <td>0.020417</td>\n",
       "      <td>-0.002566</td>\n",
       "      <td>0.000268</td>\n",
       "      <td>0.007167</td>\n",
       "      <td>-0.008398</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>...</th>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2018-11-30</th>\n",
       "      <td>-0.003151</td>\n",
       "      <td>0.010656</td>\n",
       "      <td>-0.001926</td>\n",
       "      <td>-0.004398</td>\n",
       "      <td>-0.001367</td>\n",
       "      <td>0.001452</td>\n",
       "      <td>-0.000205</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2018-12-31</th>\n",
       "      <td>0.002632</td>\n",
       "      <td>0.002620</td>\n",
       "      <td>0.001336</td>\n",
       "      <td>-0.000718</td>\n",
       "      <td>-0.000446</td>\n",
       "      <td>0.000841</td>\n",
       "      <td>0.000503</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2019-01-31</th>\n",
       "      <td>0.005300</td>\n",
       "      <td>0.001979</td>\n",
       "      <td>0.001517</td>\n",
       "      <td>-0.000180</td>\n",
       "      <td>-0.004193</td>\n",
       "      <td>0.000369</td>\n",
       "      <td>0.001274</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2019-02-28</th>\n",
       "      <td>0.001467</td>\n",
       "      <td>-0.003161</td>\n",
       "      <td>0.001589</td>\n",
       "      <td>-0.006649</td>\n",
       "      <td>0.005521</td>\n",
       "      <td>0.000577</td>\n",
       "      <td>-0.000090</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2019-03-29</th>\n",
       "      <td>0.000857</td>\n",
       "      <td>0.000945</td>\n",
       "      <td>0.001222</td>\n",
       "      <td>0.001408</td>\n",
       "      <td>0.000340</td>\n",
       "      <td>-0.000426</td>\n",
       "      <td>0.000435</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "<p>231 rows × 7 columns</p>\n",
       "</div>"
      ],
      "text/plain": [
       "              EURUSD    GBPUSD    JPYUSD    AUDUSD    CADUSD    NOKUSD  \\\n",
       "date                                                                     \n",
       "2000-01-31 -0.003022 -0.005389  0.012898 -0.000065 -0.002057 -0.006123   \n",
       "2000-02-29 -0.005529 -0.000007  0.014642 -0.000583  0.000287  0.009027   \n",
       "2000-03-31 -0.004428  0.006833  0.010626 -0.002631 -0.000590 -0.002736   \n",
       "2000-04-28 -0.004393 -0.005841  0.003849 -0.002691 -0.000777 -0.002713   \n",
       "2000-05-31 -0.010242  0.007824  0.020417 -0.002566  0.000268  0.007167   \n",
       "...              ...       ...       ...       ...       ...       ...   \n",
       "2018-11-30 -0.003151  0.010656 -0.001926 -0.004398 -0.001367  0.001452   \n",
       "2018-12-31  0.002632  0.002620  0.001336 -0.000718 -0.000446  0.000841   \n",
       "2019-01-31  0.005300  0.001979  0.001517 -0.000180 -0.004193  0.000369   \n",
       "2019-02-28  0.001467 -0.003161  0.001589 -0.006649  0.005521  0.000577   \n",
       "2019-03-29  0.000857  0.000945  0.001222  0.001408  0.000340 -0.000426   \n",
       "\n",
       "              CHFUSD  \n",
       "date                  \n",
       "2000-01-31 -0.003192  \n",
       "2000-02-29 -0.007582  \n",
       "2000-03-31 -0.005109  \n",
       "2000-04-28 -0.002774  \n",
       "2000-05-31 -0.008398  \n",
       "...              ...  \n",
       "2018-11-30 -0.000205  \n",
       "2018-12-31  0.000503  \n",
       "2019-01-31  0.001274  \n",
       "2019-02-28 -0.000090  \n",
       "2019-03-29  0.000435  \n",
       "\n",
       "[231 rows x 7 columns]"
      ]
     },
     "execution_count": 6,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "time: 24min 12s\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 6;\n",
       "                var nbb_unformatted_code = \"def model_selection_B(monthly_returns):\\n    \\\"\\\"\\\"Returns next period forecast using best model according to lower MSE on past 12 return forecasts\\\"\\\"\\\"\\n    y_true = monthly_returns.iloc[-12:].values\\n    ar_1_model_preds = []\\n    ma_1_model_preds = []\\n    for k in range(12):\\n        past_24_observations = monthly_returns.iloc[-12 + k - 24 : -12 + k]\\n\\n        ar_1_model = ARIMA(past_24_observations, order=(1, 0, 0)).fit()  # AR(1)\\n        ma_1_model = ARIMA(past_24_observations, order=(0, 0, 1)).fit()  # MA(1)\\n\\n        # Get forecast\\n        ar_1_model_pred, stderr, conf_int = ar_1_model.forecast()\\n        ma_1_model_pred, stderr, conf_int = ma_1_model.forecast()\\n\\n        ar_1_model_preds.append(ar_1_model_pred)\\n        ma_1_model_preds.append(ma_1_model_pred)\\n\\n    # Caliberated models based on past 24 month returns\\n    ar_1_model = ARIMA(monthly_returns.iloc[-24:], order=(1, 0, 0)).fit()  # AR(1)\\n    ma_1_model = ARIMA(monthly_returns.iloc[-24:], order=(0, 0, 1)).fit()  # MA(1)\\n\\n    # Select Best model based on AIC\\n    best_model = (\\n        ar_1_model\\n        if mean_squared_error(y_true=y_true, y_pred=ar_1_model_preds)\\n        < mean_squared_error(y_true=y_true, y_pred=ma_1_model_preds)\\n        else ma_1_model\\n    )\\n\\n    # Get forecast\\n    forecast, stderr, conf_int = best_model.forecast()\\n\\n    return forecast[0]\\n\\n\\nmodel_selection_B_predictions = (\\n    pd.concat(\\n        [\\n            monthly_returns[currency]\\n            .rolling(36, min_periods=36)\\n            .agg(model_selection_B)\\n            .loc[start_date:]\\n            for currency in monthly_returns.columns\\n        ],\\n        axis=1,\\n    )\\n    .shift(1)\\n    .iloc[1:]\\n)\\n\\nmodel_selection_B_predictions\";\n",
       "                var nbb_formatted_code = \"def model_selection_B(monthly_returns):\\n    \\\"\\\"\\\"Returns next period forecast using best model according to lower MSE on past 12 return forecasts\\\"\\\"\\\"\\n    y_true = monthly_returns.iloc[-12:].values\\n    ar_1_model_preds = []\\n    ma_1_model_preds = []\\n    for k in range(12):\\n        past_24_observations = monthly_returns.iloc[-12 + k - 24 : -12 + k]\\n\\n        ar_1_model = ARIMA(past_24_observations, order=(1, 0, 0)).fit()  # AR(1)\\n        ma_1_model = ARIMA(past_24_observations, order=(0, 0, 1)).fit()  # MA(1)\\n\\n        # Get forecast\\n        ar_1_model_pred, stderr, conf_int = ar_1_model.forecast()\\n        ma_1_model_pred, stderr, conf_int = ma_1_model.forecast()\\n\\n        ar_1_model_preds.append(ar_1_model_pred)\\n        ma_1_model_preds.append(ma_1_model_pred)\\n\\n    # Caliberated models based on past 24 month returns\\n    ar_1_model = ARIMA(monthly_returns.iloc[-24:], order=(1, 0, 0)).fit()  # AR(1)\\n    ma_1_model = ARIMA(monthly_returns.iloc[-24:], order=(0, 0, 1)).fit()  # MA(1)\\n\\n    # Select Best model based on AIC\\n    best_model = (\\n        ar_1_model\\n        if mean_squared_error(y_true=y_true, y_pred=ar_1_model_preds)\\n        < mean_squared_error(y_true=y_true, y_pred=ma_1_model_preds)\\n        else ma_1_model\\n    )\\n\\n    # Get forecast\\n    forecast, stderr, conf_int = best_model.forecast()\\n\\n    return forecast[0]\\n\\n\\nmodel_selection_B_predictions = (\\n    pd.concat(\\n        [\\n            monthly_returns[currency]\\n            .rolling(36, min_periods=36)\\n            .agg(model_selection_B)\\n            .loc[start_date:]\\n            for currency in monthly_returns.columns\\n        ],\\n        axis=1,\\n    )\\n    .shift(1)\\n    .iloc[1:]\\n)\\n\\nmodel_selection_B_predictions\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "def model_selection_B(monthly_returns):\n",
    "    \"\"\"Returns next period forecast using best model according to lower MSE on past 12 return forecasts\"\"\"\n",
    "    y_true = monthly_returns.iloc[-12:].values\n",
    "    ar_1_model_preds = []\n",
    "    ma_1_model_preds = []\n",
    "    for k in range(12):\n",
    "        past_24_observations = monthly_returns.iloc[-12 + k - 24 : -12 + k]\n",
    "\n",
    "        ar_1_model = ARIMA(past_24_observations, order=(1, 0, 0)).fit()  # AR(1)\n",
    "        ma_1_model = ARIMA(past_24_observations, order=(0, 0, 1)).fit()  # MA(1)\n",
    "\n",
    "        # Get forecast\n",
    "        ar_1_model_pred, stderr, conf_int = ar_1_model.forecast()\n",
    "        ma_1_model_pred, stderr, conf_int = ma_1_model.forecast()\n",
    "\n",
    "        ar_1_model_preds.append(ar_1_model_pred)\n",
    "        ma_1_model_preds.append(ma_1_model_pred)\n",
    "\n",
    "    # Caliberated models based on past 24 month returns\n",
    "    ar_1_model = ARIMA(monthly_returns.iloc[-24:], order=(1, 0, 0)).fit()  # AR(1)\n",
    "    ma_1_model = ARIMA(monthly_returns.iloc[-24:], order=(0, 0, 1)).fit()  # MA(1)\n",
    "\n",
    "    # Select Best model based on AIC\n",
    "    best_model = (\n",
    "        ar_1_model\n",
    "        if mean_squared_error(y_true=y_true, y_pred=ar_1_model_preds)\n",
    "        < mean_squared_error(y_true=y_true, y_pred=ma_1_model_preds)\n",
    "        else ma_1_model\n",
    "    )\n",
    "\n",
    "    # Get forecast\n",
    "    forecast, stderr, conf_int = best_model.forecast()\n",
    "\n",
    "    return forecast[0]\n",
    "\n",
    "\n",
    "model_selection_B_predictions = (\n",
    "    pd.concat(\n",
    "        [\n",
    "            monthly_returns[currency]\n",
    "            .rolling(36, min_periods=36)\n",
    "            .agg(model_selection_B)\n",
    "            .loc[start_date:]\n",
    "            for currency in monthly_returns.columns\n",
    "        ],\n",
    "        axis=1,\n",
    "    )\n",
    "    .shift(1)\n",
    "    .iloc[1:]\n",
    ")\n",
    "\n",
    "model_selection_B_predictions"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "## Step 3:\t\n",
    "\n",
    "Now at time t, we have made our forecasts for the seven currencies of their monthly returns at t+1.\n",
    "\n",
    "Suppose the forecasted returns are (r1,r2,…,r7). \n",
    "\n",
    "We'll transform the forecasts to return sign only: (sign(r1),sign(r2),…,sign(r7)).\n",
    "\n",
    "We'll invest in currency h with a long position if sign(rh)=1, otherwise we'll invest in it with a short position.\n",
    "But right now, we need to figure out the weight vector based on Risk Parity.\n",
    "\n",
    "Prepare the covariance matrix corresponding to (sign(r1),sign(r2),…,sign(r7)), i.e., for currency h, if sign(rh)=1, we use the currency's original returns; otherwise, use the negative of original returns. Then we'll calculate the covariance matrix based on past 60 monthly returns (time t included) (**ASSUMPTION 1. I assume that the past 60 monthly returns refer to the original past 60 monthly returns, not the ones we forecast using model A / B**).\n",
    "\n",
    "Based on the covariance matrix, run Risk Parity program (see class slide) to get a weight vector (w1, …, w7) whose summation equals 1. However, we'll target an annualized volatility of 5%, i.e., we'll invest with the updated weight vector (w1*,…,w7*)=the levarage factor x(w1,…,w7) where the leverage factor = 5%/(the expected volatility of the portfolio given (w1,…,w7)) (**ASSUMPTION 2. I assume that the expected volatility here refers to the annualized expected volatility of the portfolio**).\n",
    "\n",
    "Note: w1*,…, w7* are all of positive values"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 7,
   "metadata": {
    "scrolled": false
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>EURUSD</th>\n",
       "      <th>GBPUSD</th>\n",
       "      <th>JPYUSD</th>\n",
       "      <th>AUDUSD</th>\n",
       "      <th>CADUSD</th>\n",
       "      <th>NOKUSD</th>\n",
       "      <th>CHFUSD</th>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>date</th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>2000-01-31</th>\n",
       "      <td>0.035281</td>\n",
       "      <td>0.001236</td>\n",
       "      <td>-0.045310</td>\n",
       "      <td>0.029998</td>\n",
       "      <td>0.001157</td>\n",
       "      <td>-0.036889</td>\n",
       "      <td>0.040401</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-02-29</th>\n",
       "      <td>0.006696</td>\n",
       "      <td>0.022893</td>\n",
       "      <td>-0.026415</td>\n",
       "      <td>0.030141</td>\n",
       "      <td>-0.001593</td>\n",
       "      <td>-0.007494</td>\n",
       "      <td>0.004641</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-03-31</th>\n",
       "      <td>0.009023</td>\n",
       "      <td>0.007535</td>\n",
       "      <td>0.072902</td>\n",
       "      <td>0.017320</td>\n",
       "      <td>-0.000870</td>\n",
       "      <td>-0.009228</td>\n",
       "      <td>-0.000000</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-04-28</th>\n",
       "      <td>0.045631</td>\n",
       "      <td>0.025014</td>\n",
       "      <td>0.049856</td>\n",
       "      <td>0.038214</td>\n",
       "      <td>0.021008</td>\n",
       "      <td>0.053345</td>\n",
       "      <td>0.029642</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-05-31</th>\n",
       "      <td>-0.028622</td>\n",
       "      <td>-0.032167</td>\n",
       "      <td>0.004977</td>\n",
       "      <td>0.019524</td>\n",
       "      <td>-0.011100</td>\n",
       "      <td>0.006261</td>\n",
       "      <td>-0.021452</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>...</th>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2018-11-30</th>\n",
       "      <td>-0.000442</td>\n",
       "      <td>-0.001332</td>\n",
       "      <td>-0.004631</td>\n",
       "      <td>-0.032942</td>\n",
       "      <td>0.010132</td>\n",
       "      <td>-0.018565</td>\n",
       "      <td>0.009882</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2018-12-31</th>\n",
       "      <td>0.013254</td>\n",
       "      <td>0.000392</td>\n",
       "      <td>0.035293</td>\n",
       "      <td>0.035177</td>\n",
       "      <td>0.025389</td>\n",
       "      <td>-0.005159</td>\n",
       "      <td>0.017174</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2019-01-31</th>\n",
       "      <td>-0.001657</td>\n",
       "      <td>0.027834</td>\n",
       "      <td>0.006906</td>\n",
       "      <td>-0.031778</td>\n",
       "      <td>-0.039143</td>\n",
       "      <td>0.025065</td>\n",
       "      <td>-0.012761</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2019-02-28</th>\n",
       "      <td>-0.006726</td>\n",
       "      <td>-0.011748</td>\n",
       "      <td>-0.022643</td>\n",
       "      <td>0.024612</td>\n",
       "      <td>-0.003938</td>\n",
       "      <td>-0.015177</td>\n",
       "      <td>0.003679</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2019-03-29</th>\n",
       "      <td>-0.010289</td>\n",
       "      <td>-0.006107</td>\n",
       "      <td>0.011027</td>\n",
       "      <td>-0.000564</td>\n",
       "      <td>0.017525</td>\n",
       "      <td>0.007705</td>\n",
       "      <td>0.002994</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "<p>231 rows × 7 columns</p>\n",
       "</div>"
      ],
      "text/plain": [
       "              EURUSD    GBPUSD    JPYUSD    AUDUSD    CADUSD    NOKUSD  \\\n",
       "date                                                                     \n",
       "2000-01-31  0.035281  0.001236 -0.045310  0.029998  0.001157 -0.036889   \n",
       "2000-02-29  0.006696  0.022893 -0.026415  0.030141 -0.001593 -0.007494   \n",
       "2000-03-31  0.009023  0.007535  0.072902  0.017320 -0.000870 -0.009228   \n",
       "2000-04-28  0.045631  0.025014  0.049856  0.038214  0.021008  0.053345   \n",
       "2000-05-31 -0.028622 -0.032167  0.004977  0.019524 -0.011100  0.006261   \n",
       "...              ...       ...       ...       ...       ...       ...   \n",
       "2018-11-30 -0.000442 -0.001332 -0.004631 -0.032942  0.010132 -0.018565   \n",
       "2018-12-31  0.013254  0.000392  0.035293  0.035177  0.025389 -0.005159   \n",
       "2019-01-31 -0.001657  0.027834  0.006906 -0.031778 -0.039143  0.025065   \n",
       "2019-02-28 -0.006726 -0.011748 -0.022643  0.024612 -0.003938 -0.015177   \n",
       "2019-03-29 -0.010289 -0.006107  0.011027 -0.000564  0.017525  0.007705   \n",
       "\n",
       "              CHFUSD  \n",
       "date                  \n",
       "2000-01-31  0.040401  \n",
       "2000-02-29  0.004641  \n",
       "2000-03-31 -0.000000  \n",
       "2000-04-28  0.029642  \n",
       "2000-05-31 -0.021452  \n",
       "...              ...  \n",
       "2018-11-30  0.009882  \n",
       "2018-12-31  0.017174  \n",
       "2019-01-31 -0.012761  \n",
       "2019-02-28  0.003679  \n",
       "2019-03-29  0.002994  \n",
       "\n",
       "[231 rows x 7 columns]"
      ]
     },
     "execution_count": 7,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "time: 20.8 ms\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 7;\n",
       "                var nbb_unformatted_code = \"A_returns = monthly_returns.loc[model_selection_A_predictions.index[0] :] * np.sign(\\n    model_selection_A_predictions\\n)\\n\\nA_returns\";\n",
       "                var nbb_formatted_code = \"A_returns = monthly_returns.loc[model_selection_A_predictions.index[0] :] * np.sign(\\n    model_selection_A_predictions\\n)\\n\\nA_returns\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "A_returns = monthly_returns.loc[model_selection_A_predictions.index[0] :] * np.sign(\n",
    "    model_selection_A_predictions\n",
    ")\n",
    "\n",
    "A_returns"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 8,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>EURUSD</th>\n",
       "      <th>GBPUSD</th>\n",
       "      <th>JPYUSD</th>\n",
       "      <th>AUDUSD</th>\n",
       "      <th>CADUSD</th>\n",
       "      <th>NOKUSD</th>\n",
       "      <th>CHFUSD</th>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>date</th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "      <th></th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>2000-01-31</th>\n",
       "      <td>0.035281</td>\n",
       "      <td>0.001236</td>\n",
       "      <td>-0.045310</td>\n",
       "      <td>0.029998</td>\n",
       "      <td>0.001157</td>\n",
       "      <td>0.036889</td>\n",
       "      <td>0.040401</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-02-29</th>\n",
       "      <td>0.006696</td>\n",
       "      <td>0.022893</td>\n",
       "      <td>-0.026415</td>\n",
       "      <td>0.030141</td>\n",
       "      <td>-0.001593</td>\n",
       "      <td>-0.007494</td>\n",
       "      <td>0.004641</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-03-31</th>\n",
       "      <td>0.009023</td>\n",
       "      <td>0.007535</td>\n",
       "      <td>0.072902</td>\n",
       "      <td>0.017320</td>\n",
       "      <td>-0.000870</td>\n",
       "      <td>0.009228</td>\n",
       "      <td>-0.000000</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-04-28</th>\n",
       "      <td>0.045631</td>\n",
       "      <td>0.025014</td>\n",
       "      <td>-0.049856</td>\n",
       "      <td>0.038214</td>\n",
       "      <td>0.021008</td>\n",
       "      <td>0.053345</td>\n",
       "      <td>0.029642</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-05-31</th>\n",
       "      <td>-0.028622</td>\n",
       "      <td>-0.032167</td>\n",
       "      <td>0.004977</td>\n",
       "      <td>0.019524</td>\n",
       "      <td>-0.011100</td>\n",
       "      <td>0.006261</td>\n",
       "      <td>-0.021452</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>...</th>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2018-11-30</th>\n",
       "      <td>-0.000442</td>\n",
       "      <td>-0.001332</td>\n",
       "      <td>0.004631</td>\n",
       "      <td>-0.032942</td>\n",
       "      <td>0.010132</td>\n",
       "      <td>-0.018565</td>\n",
       "      <td>-0.009882</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2018-12-31</th>\n",
       "      <td>0.013254</td>\n",
       "      <td>0.000392</td>\n",
       "      <td>0.035293</td>\n",
       "      <td>0.035177</td>\n",
       "      <td>0.025389</td>\n",
       "      <td>-0.005159</td>\n",
       "      <td>0.017174</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2019-01-31</th>\n",
       "      <td>-0.001657</td>\n",
       "      <td>0.027834</td>\n",
       "      <td>0.006906</td>\n",
       "      <td>-0.031778</td>\n",
       "      <td>-0.039143</td>\n",
       "      <td>0.025065</td>\n",
       "      <td>-0.012761</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2019-02-28</th>\n",
       "      <td>-0.006726</td>\n",
       "      <td>-0.011748</td>\n",
       "      <td>-0.022643</td>\n",
       "      <td>0.024612</td>\n",
       "      <td>-0.003938</td>\n",
       "      <td>-0.015177</td>\n",
       "      <td>0.003679</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2019-03-29</th>\n",
       "      <td>-0.010289</td>\n",
       "      <td>-0.006107</td>\n",
       "      <td>0.011027</td>\n",
       "      <td>-0.000564</td>\n",
       "      <td>-0.017525</td>\n",
       "      <td>0.007705</td>\n",
       "      <td>0.002994</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "<p>231 rows × 7 columns</p>\n",
       "</div>"
      ],
      "text/plain": [
       "              EURUSD    GBPUSD    JPYUSD    AUDUSD    CADUSD    NOKUSD  \\\n",
       "date                                                                     \n",
       "2000-01-31  0.035281  0.001236 -0.045310  0.029998  0.001157  0.036889   \n",
       "2000-02-29  0.006696  0.022893 -0.026415  0.030141 -0.001593 -0.007494   \n",
       "2000-03-31  0.009023  0.007535  0.072902  0.017320 -0.000870  0.009228   \n",
       "2000-04-28  0.045631  0.025014 -0.049856  0.038214  0.021008  0.053345   \n",
       "2000-05-31 -0.028622 -0.032167  0.004977  0.019524 -0.011100  0.006261   \n",
       "...              ...       ...       ...       ...       ...       ...   \n",
       "2018-11-30 -0.000442 -0.001332  0.004631 -0.032942  0.010132 -0.018565   \n",
       "2018-12-31  0.013254  0.000392  0.035293  0.035177  0.025389 -0.005159   \n",
       "2019-01-31 -0.001657  0.027834  0.006906 -0.031778 -0.039143  0.025065   \n",
       "2019-02-28 -0.006726 -0.011748 -0.022643  0.024612 -0.003938 -0.015177   \n",
       "2019-03-29 -0.010289 -0.006107  0.011027 -0.000564 -0.017525  0.007705   \n",
       "\n",
       "              CHFUSD  \n",
       "date                  \n",
       "2000-01-31  0.040401  \n",
       "2000-02-29  0.004641  \n",
       "2000-03-31 -0.000000  \n",
       "2000-04-28  0.029642  \n",
       "2000-05-31 -0.021452  \n",
       "...              ...  \n",
       "2018-11-30 -0.009882  \n",
       "2018-12-31  0.017174  \n",
       "2019-01-31 -0.012761  \n",
       "2019-02-28  0.003679  \n",
       "2019-03-29  0.002994  \n",
       "\n",
       "[231 rows x 7 columns]"
      ]
     },
     "execution_count": 8,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "time: 15.8 ms\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 8;\n",
       "                var nbb_unformatted_code = \"B_returns = monthly_returns.loc[model_selection_B_predictions.index[0] :] * np.sign(\\n    model_selection_B_predictions\\n)\\n\\nB_returns\";\n",
       "                var nbb_formatted_code = \"B_returns = monthly_returns.loc[model_selection_B_predictions.index[0] :] * np.sign(\\n    model_selection_B_predictions\\n)\\n\\nB_returns\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "B_returns = monthly_returns.loc[model_selection_B_predictions.index[0] :] * np.sign(\n",
    "    model_selection_B_predictions\n",
    ")\n",
    "\n",
    "B_returns"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Risk-Parity Program:\n",
    "\n",
    "\\begin{align}\n",
    "    \\underset{w}{\\text{minimize }} &{(\\mathbb{CR} - b\\sigma(w))}^\\top {(\\mathbb{CR} - b\\sigma(w))} \\\\\n",
    "    \\text{subject to } &w^\\top \\mathbb{1} = 1 \\text{ and } 0 \\leq w \\leq 1 \\\\ \n",
    "    \\text{where } &b_i = \\frac{1}{n}\\qquad\\forall i \\in 1, \\cdots, n, \\\\\n",
    "    \\text{and } &\\mathbb{CR} = \\frac{\\text{diag}(w)\\Sigma w}{\\sigma(w)} \\\\\n",
    "    &\\mathbb{MCR} = \\frac{\\Sigma w}{\\sigma(w)} \\\\\n",
    "    &\\sigma(w) = \\sqrt{w^\\top\\Sigma w}\n",
    "\\end{align}"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 9,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "time: 3.7 ms\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 9;\n",
       "                var nbb_unformatted_code = \"def risk_budgeting_weights(\\u03a3, b, target_ann_vol=0.05):\\n    \\\"\\\"\\\"Solves risk-budgeting program and returns optimal\\n    weights for each asset such that the volatility of \\n    each asset in portfolio conforms to the risk budget\\n    allocated using differential evolution.\\n    \\n    Args:\\n        \\u03a3 (np.array): Covariance matrix of the monthly asset returns\\n        b (np.array): Risk budgets\\n        target_ann_vol (float): Target annualized volatility, default - 0.05\\n        \\n    Returns:\\n        (np.array): Weight vector\\n    \\\"\\\"\\\"\\n    n = \\u03a3.shape[0]  # Number of assets in portfolio\\n    \\u03c3 = lambda w, \\u03a3: np.sqrt(w.T @ \\u03a3 @ w)  # Portfolio volatility\\n    MCR = lambda w, \\u03a3, \\u03c3: (\\u03a3 @ w) / \\u03c3  # Marginal Contribution to Risk\\n    CR = lambda w, \\u03a3, \\u03c3: np.diag(w) @ MCR(w, \\u03a3, \\u03c3)  # Contribution to Risk\\n    obj = lambda w: (CR(w, \\u03a3, \\u03c3(w, \\u03a3)) - b.T * \\u03c3(w, \\u03a3)).T @ (\\n        CR(w, \\u03a3, \\u03c3(w, \\u03a3)) - b.T * \\u03c3(w, \\u03a3)\\n    )  # Form objective\\n    result = sp.optimize.differential_evolution(\\n        func=obj,\\n        bounds=[(0, 1) for _ in range(n)],\\n        maxiter=1000,\\n        popsize=15,\\n        constraints=(\\n            sp.optimize.LinearConstraint(A=np.ones(shape=(n,)), lb=1, ub=1),  # \\ud835\\udc64\\u22a4\\ud835\\udfd9 = 1\\n            sp.optimize.LinearConstraint(\\n                A=np.eye(n), lb=np.zeros(shape=(n,)), ub=np.ones(shape=(n,)),\\n            ),  # 0 \\u2264 \\ud835\\udc64 \\u2264 1\\n        ),\\n    )\\n\\n    # Optimal weight vector\\n    w_star = result.x\\n\\n    # Update weight vector to target annualized volatility\\n    # By normalizing the weights according to their expected\\n    # annualized volatility and then x 5% target annualized volatility\\n    leverage_factor = target_ann_vol / (\\u03c3(w_star, \\u03a3) * np.sqrt(12))\\n    w_star *= leverage_factor\\n\\n    # Form and solve problem.\\n    return w_star\";\n",
       "                var nbb_formatted_code = \"def risk_budgeting_weights(\\u03a3, b, target_ann_vol=0.05):\\n    \\\"\\\"\\\"Solves risk-budgeting program and returns optimal\\n    weights for each asset such that the volatility of \\n    each asset in portfolio conforms to the risk budget\\n    allocated using differential evolution.\\n    \\n    Args:\\n        \\u03a3 (np.array): Covariance matrix of the monthly asset returns\\n        b (np.array): Risk budgets\\n        target_ann_vol (float): Target annualized volatility, default - 0.05\\n        \\n    Returns:\\n        (np.array): Weight vector\\n    \\\"\\\"\\\"\\n    n = \\u03a3.shape[0]  # Number of assets in portfolio\\n    \\u03c3 = lambda w, \\u03a3: np.sqrt(w.T @ \\u03a3 @ w)  # Portfolio volatility\\n    MCR = lambda w, \\u03a3, \\u03c3: (\\u03a3 @ w) / \\u03c3  # Marginal Contribution to Risk\\n    CR = lambda w, \\u03a3, \\u03c3: np.diag(w) @ MCR(w, \\u03a3, \\u03c3)  # Contribution to Risk\\n    obj = lambda w: (CR(w, \\u03a3, \\u03c3(w, \\u03a3)) - b.T * \\u03c3(w, \\u03a3)).T @ (\\n        CR(w, \\u03a3, \\u03c3(w, \\u03a3)) - b.T * \\u03c3(w, \\u03a3)\\n    )  # Form objective\\n    result = sp.optimize.differential_evolution(\\n        func=obj,\\n        bounds=[(0, 1) for _ in range(n)],\\n        maxiter=1000,\\n        popsize=15,\\n        constraints=(\\n            sp.optimize.LinearConstraint(A=np.ones(shape=(n,)), lb=1, ub=1),  # \\ud835\\udc64\\u22a4\\ud835\\udfd9 = 1\\n            sp.optimize.LinearConstraint(\\n                A=np.eye(n), lb=np.zeros(shape=(n,)), ub=np.ones(shape=(n,)),\\n            ),  # 0 \\u2264 \\ud835\\udc64 \\u2264 1\\n        ),\\n    )\\n\\n    # Optimal weight vector\\n    w_star = result.x\\n\\n    # Update weight vector to target annualized volatility\\n    # By normalizing the weights according to their expected\\n    # annualized volatility and then x 5% target annualized volatility\\n    leverage_factor = target_ann_vol / (\\u03c3(w_star, \\u03a3) * np.sqrt(12))\\n    w_star *= leverage_factor\\n\\n    # Form and solve problem.\\n    return w_star\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "def risk_budgeting_weights(Σ, b, target_ann_vol=0.05):\n",
    "    \"\"\"Solves risk-budgeting program and returns optimal\n",
    "    weights for each asset such that the volatility of \n",
    "    each asset in portfolio conforms to the risk budget\n",
    "    allocated using differential evolution.\n",
    "    \n",
    "    Args:\n",
    "        Σ (np.array): Covariance matrix of the monthly asset returns\n",
    "        b (np.array): Risk budgets\n",
    "        target_ann_vol (float): Target annualized volatility, default - 0.05\n",
    "        \n",
    "    Returns:\n",
    "        (np.array): Weight vector\n",
    "    \"\"\"\n",
    "    n = Σ.shape[0]  # Number of assets in portfolio\n",
    "    σ = lambda w, Σ: np.sqrt(w.T @ Σ @ w)  # Portfolio volatility\n",
    "    MCR = lambda w, Σ, σ: (Σ @ w) / σ  # Marginal Contribution to Risk\n",
    "    CR = lambda w, Σ, σ: np.diag(w) @ MCR(w, Σ, σ)  # Contribution to Risk\n",
    "    obj = lambda w: (CR(w, Σ, σ(w, Σ)) - b.T * σ(w, Σ)).T @ (\n",
    "        CR(w, Σ, σ(w, Σ)) - b.T * σ(w, Σ)\n",
    "    )  # Form objective\n",
    "    result = sp.optimize.differential_evolution(\n",
    "        func=obj,\n",
    "        bounds=[(0, 1) for _ in range(n)],\n",
    "        maxiter=1000,\n",
    "        popsize=15,\n",
    "        constraints=(\n",
    "            sp.optimize.LinearConstraint(A=np.ones(shape=(n,)), lb=1, ub=1),  # 𝑤⊤𝟙 = 1\n",
    "            sp.optimize.LinearConstraint(\n",
    "                A=np.eye(n), lb=np.zeros(shape=(n,)), ub=np.ones(shape=(n,)),\n",
    "            ),  # 0 ≤ 𝑤 ≤ 1\n",
    "        ),\n",
    "    )\n",
    "\n",
    "    # Optimal weight vector\n",
    "    w_star = result.x\n",
    "\n",
    "    # Update weight vector to target annualized volatility\n",
    "    # By normalizing the weights according to their expected\n",
    "    # annualized volatility and then x 5% target annualized volatility\n",
    "    leverage_factor = target_ann_vol / (σ(w_star, Σ) * np.sqrt(12))\n",
    "    w_star *= leverage_factor\n",
    "\n",
    "    # Form and solve problem.\n",
    "    return w_star"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "---\n",
    "## Step 4:\t\n",
    "\n",
    "the portfolio (w1*,…,w7*)'s return at time t+1 will be calculated as (sign(r1) x w1* x r1_new+…+ sign(r7) x w1* x r7_new) where sign(rh) is your directional forecast for currency h at time t+1, and rh_new is its actual return at time t+1. \n",
    "\n",
    "Record the portfolio's returns at time t+1, and go to Step 2 to make forecast for time t+2 and build the portfolio, and stop until 3/29/2019."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 10,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "time: 2.35 ms\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 10;\n",
       "                var nbb_unformatted_code = \"annualized_volatility = (\\n    lambda monthly_returns: np.std(monthly_returns) * np.sqrt(12)\\n    if len(monthly_returns) > 0\\n    else None\\n)\\nannualized_return = (\\n    lambda monthly_returns: np.prod(monthly_returns + 1) ** (12 / len(monthly_returns))\\n    - 1\\n    if len(monthly_returns) > 0\\n    else None\\n)\\n\\n\\ndef sharpe_ratio(monthly_returns, R_f=0):\\n    R_p = annualized_return(monthly_returns)\\n    \\u03c3_p = annualized_volatility(monthly_returns)\\n    return (R_p - R_f) / \\u03c3_p if len(monthly_returns) > 0 else None\\n\\n\\ndef get_risk_parity_returns(past_returns, forecasted_returns):\\n    n = len(past_returns.columns)\\n    \\u03a3 = past_returns.cov().values\\n    b = np.array([1] * n) / n\\n    risk_parity_weights = risk_budgeting_weights(\\u03a3, b)\\n    return risk_parity_weights.T @ forecasted_returns\";\n",
       "                var nbb_formatted_code = \"annualized_volatility = (\\n    lambda monthly_returns: np.std(monthly_returns) * np.sqrt(12)\\n    if len(monthly_returns) > 0\\n    else None\\n)\\nannualized_return = (\\n    lambda monthly_returns: np.prod(monthly_returns + 1) ** (12 / len(monthly_returns))\\n    - 1\\n    if len(monthly_returns) > 0\\n    else None\\n)\\n\\n\\ndef sharpe_ratio(monthly_returns, R_f=0):\\n    R_p = annualized_return(monthly_returns)\\n    \\u03c3_p = annualized_volatility(monthly_returns)\\n    return (R_p - R_f) / \\u03c3_p if len(monthly_returns) > 0 else None\\n\\n\\ndef get_risk_parity_returns(past_returns, forecasted_returns):\\n    n = len(past_returns.columns)\\n    \\u03a3 = past_returns.cov().values\\n    b = np.array([1] * n) / n\\n    risk_parity_weights = risk_budgeting_weights(\\u03a3, b)\\n    return risk_parity_weights.T @ forecasted_returns\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "annualized_volatility = (\n",
    "    lambda monthly_returns: np.std(monthly_returns) * np.sqrt(12)\n",
    "    if len(monthly_returns) > 0\n",
    "    else None\n",
    ")\n",
    "annualized_return = (\n",
    "    lambda monthly_returns: np.prod(monthly_returns + 1) ** (12 / len(monthly_returns))\n",
    "    - 1\n",
    "    if len(monthly_returns) > 0\n",
    "    else None\n",
    ")\n",
    "\n",
    "\n",
    "def sharpe_ratio(monthly_returns, R_f=0):\n",
    "    R_p = annualized_return(monthly_returns)\n",
    "    σ_p = annualized_volatility(monthly_returns)\n",
    "    return (R_p - R_f) / σ_p if len(monthly_returns) > 0 else None\n",
    "\n",
    "\n",
    "def get_risk_parity_returns(past_returns, forecasted_returns):\n",
    "    n = len(past_returns.columns)\n",
    "    Σ = past_returns.cov().values\n",
    "    b = np.array([1] * n) / n\n",
    "    risk_parity_weights = risk_budgeting_weights(Σ, b)\n",
    "    return risk_parity_weights.T @ forecasted_returns"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 11,
   "metadata": {
    "scrolled": false
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>returns</th>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>date</th>\n",
       "      <th></th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>2000-01-31</th>\n",
       "      <td>0.006108</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-02-29</th>\n",
       "      <td>0.006802</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-03-31</th>\n",
       "      <td>0.009838</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-04-28</th>\n",
       "      <td>0.038707</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-05-31</th>\n",
       "      <td>-0.011690</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>...</th>\n",
       "      <td>...</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2018-11-30</th>\n",
       "      <td>-0.003069</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2018-12-31</th>\n",
       "      <td>0.014000</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2019-01-31</th>\n",
       "      <td>-0.002045</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2019-02-28</th>\n",
       "      <td>-0.004150</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2019-03-29</th>\n",
       "      <td>0.002271</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "<p>231 rows × 1 columns</p>\n",
       "</div>"
      ],
      "text/plain": [
       "             returns\n",
       "date                \n",
       "2000-01-31  0.006108\n",
       "2000-02-29  0.006802\n",
       "2000-03-31  0.009838\n",
       "2000-04-28  0.038707\n",
       "2000-05-31 -0.011690\n",
       "...              ...\n",
       "2018-11-30 -0.003069\n",
       "2018-12-31  0.014000\n",
       "2019-01-31 -0.002045\n",
       "2019-02-28 -0.004150\n",
       "2019-03-29  0.002271\n",
       "\n",
       "[231 rows x 1 columns]"
      ]
     },
     "execution_count": 11,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "time: 39min 23s\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 11;\n",
       "                var nbb_unformatted_code = \"A_risk_parity_returns = (\\n    pd.Series(\\n        [\\n            get_risk_parity_returns(\\n                past_returns=monthly_returns.iloc[\\n                    monthly_returns.index.get_loc(start_date)\\n                    - 60\\n                    + start_idx : monthly_returns.index.get_loc(start_date)\\n                    + start_idx,\\n                    :,\\n                ],\\n                forecasted_returns=A_returns.loc[\\n                    monthly_returns.iloc[monthly_returns.index.get_loc(start_date) + start_idx].name\\n                ],\\n            ) for start_idx in range(1, monthly_returns.shape[0] - monthly_returns.index.get_loc(start_date))\\n        ],\\n        index=A_returns.loc[start_date:].index,\\n    )\\n    .to_frame()\\n    .rename({0: \\\"returns\\\"}, axis=1)\\n)\\nA_risk_parity_returns\";\n",
       "                var nbb_formatted_code = \"A_risk_parity_returns = (\\n    pd.Series(\\n        [\\n            get_risk_parity_returns(\\n                past_returns=monthly_returns.iloc[\\n                    monthly_returns.index.get_loc(start_date)\\n                    - 60\\n                    + start_idx : monthly_returns.index.get_loc(start_date)\\n                    + start_idx,\\n                    :,\\n                ],\\n                forecasted_returns=A_returns.loc[\\n                    monthly_returns.iloc[\\n                        monthly_returns.index.get_loc(start_date) + start_idx\\n                    ].name\\n                ],\\n            )\\n            for start_idx in range(\\n                1, monthly_returns.shape[0] - monthly_returns.index.get_loc(start_date)\\n            )\\n        ],\\n        index=A_returns.loc[start_date:].index,\\n    )\\n    .to_frame()\\n    .rename({0: \\\"returns\\\"}, axis=1)\\n)\\nA_risk_parity_returns\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "A_risk_parity_returns = (\n",
    "    pd.Series(\n",
    "        [\n",
    "            get_risk_parity_returns(\n",
    "                past_returns=monthly_returns.iloc[\n",
    "                    monthly_returns.index.get_loc(start_date)\n",
    "                    - 60\n",
    "                    + start_idx : monthly_returns.index.get_loc(start_date)\n",
    "                    + start_idx,\n",
    "                    :,\n",
    "                ],\n",
    "                forecasted_returns=A_returns.loc[\n",
    "                    monthly_returns.iloc[\n",
    "                        monthly_returns.index.get_loc(start_date) + start_idx\n",
    "                    ].name\n",
    "                ],\n",
    "            )\n",
    "            for start_idx in range(\n",
    "                1, monthly_returns.shape[0] - monthly_returns.index.get_loc(start_date)\n",
    "            )\n",
    "        ],\n",
    "        index=A_returns.loc[start_date:].index,\n",
    "    )\n",
    "    .to_frame()\n",
    "    .rename({0: \"returns\"}, axis=1)\n",
    ")\n",
    "A_risk_parity_returns"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 12,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Risk-Parity with Model Selection A: \n",
      "Annualized Return: 0.006451740379742388\n",
      "Annualized Volatility: 0.04123175329661224\n",
      "Annualized Sharpe Ratio: 0.15647504323500325\n",
      "time: 1.48 ms\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 12;\n",
       "                var nbb_unformatted_code = \"print(f\\\"Risk-Parity with Model Selection A: \\\")\\nprint(f\\\"Annualized Return:\\\", annualized_return(A_risk_parity_returns.values))\\nprint(f\\\"Annualized Volatility:\\\", annualized_volatility(A_risk_parity_returns.values))\\nprint(f\\\"Annualized Sharpe Ratio:\\\", sharpe_ratio(A_risk_parity_returns.values))\";\n",
       "                var nbb_formatted_code = \"print(f\\\"Risk-Parity with Model Selection A: \\\")\\nprint(f\\\"Annualized Return:\\\", annualized_return(A_risk_parity_returns.values))\\nprint(f\\\"Annualized Volatility:\\\", annualized_volatility(A_risk_parity_returns.values))\\nprint(f\\\"Annualized Sharpe Ratio:\\\", sharpe_ratio(A_risk_parity_returns.values))\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "print(f\"Risk-Parity with Model Selection A: \")\n",
    "print(f\"Annualized Return:\", annualized_return(A_risk_parity_returns.values))\n",
    "print(f\"Annualized Volatility:\", annualized_volatility(A_risk_parity_returns.values))\n",
    "print(f\"Annualized Sharpe Ratio:\", sharpe_ratio(A_risk_parity_returns.values))"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 13,
   "metadata": {
    "scrolled": false
   },
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>returns</th>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>date</th>\n",
       "      <th></th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>2000-01-31</th>\n",
       "      <td>0.014290</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-02-29</th>\n",
       "      <td>0.006797</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-03-31</th>\n",
       "      <td>0.011856</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-04-28</th>\n",
       "      <td>0.029459</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2000-05-31</th>\n",
       "      <td>-0.011655</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>...</th>\n",
       "      <td>...</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2018-11-30</th>\n",
       "      <td>-0.004471</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2018-12-31</th>\n",
       "      <td>0.014027</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2019-01-31</th>\n",
       "      <td>-0.002052</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2019-02-28</th>\n",
       "      <td>-0.004151</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2019-03-29</th>\n",
       "      <td>-0.001552</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "<p>231 rows × 1 columns</p>\n",
       "</div>"
      ],
      "text/plain": [
       "             returns\n",
       "date                \n",
       "2000-01-31  0.014290\n",
       "2000-02-29  0.006797\n",
       "2000-03-31  0.011856\n",
       "2000-04-28  0.029459\n",
       "2000-05-31 -0.011655\n",
       "...              ...\n",
       "2018-11-30 -0.004471\n",
       "2018-12-31  0.014027\n",
       "2019-01-31 -0.002052\n",
       "2019-02-28 -0.004151\n",
       "2019-03-29 -0.001552\n",
       "\n",
       "[231 rows x 1 columns]"
      ]
     },
     "execution_count": 13,
     "metadata": {},
     "output_type": "execute_result"
    },
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "time: 35min 53s\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 13;\n",
       "                var nbb_unformatted_code = \"B_risk_parity_returns = (\\n    pd.Series(\\n        [\\n            get_risk_parity_returns(\\n                past_returns=monthly_returns.iloc[\\n                    monthly_returns.index.get_loc(start_date)\\n                    - 60\\n                    + start_idx : monthly_returns.index.get_loc(start_date)\\n                    + start_idx,\\n                    :,\\n                ],\\n                forecasted_returns=B_returns.loc[\\n                    monthly_returns.iloc[monthly_returns.index.get_loc(start_date) + start_idx].name\\n                ],\\n            ) for start_idx in range(1, monthly_returns.shape[0] - monthly_returns.index.get_loc(start_date))\\n        ],\\n        index=B_returns.loc[start_date:].index,\\n    )\\n    .to_frame()\\n    .rename({0: \\\"returns\\\"}, axis=1)\\n)\\nB_risk_parity_returns\";\n",
       "                var nbb_formatted_code = \"B_risk_parity_returns = (\\n    pd.Series(\\n        [\\n            get_risk_parity_returns(\\n                past_returns=monthly_returns.iloc[\\n                    monthly_returns.index.get_loc(start_date)\\n                    - 60\\n                    + start_idx : monthly_returns.index.get_loc(start_date)\\n                    + start_idx,\\n                    :,\\n                ],\\n                forecasted_returns=B_returns.loc[\\n                    monthly_returns.iloc[\\n                        monthly_returns.index.get_loc(start_date) + start_idx\\n                    ].name\\n                ],\\n            )\\n            for start_idx in range(\\n                1, monthly_returns.shape[0] - monthly_returns.index.get_loc(start_date)\\n            )\\n        ],\\n        index=B_returns.loc[start_date:].index,\\n    )\\n    .to_frame()\\n    .rename({0: \\\"returns\\\"}, axis=1)\\n)\\nB_risk_parity_returns\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "B_risk_parity_returns = (\n",
    "    pd.Series(\n",
    "        [\n",
    "            get_risk_parity_returns(\n",
    "                past_returns=monthly_returns.iloc[\n",
    "                    monthly_returns.index.get_loc(start_date)\n",
    "                    - 60\n",
    "                    + start_idx : monthly_returns.index.get_loc(start_date)\n",
    "                    + start_idx,\n",
    "                    :,\n",
    "                ],\n",
    "                forecasted_returns=B_returns.loc[\n",
    "                    monthly_returns.iloc[\n",
    "                        monthly_returns.index.get_loc(start_date) + start_idx\n",
    "                    ].name\n",
    "                ],\n",
    "            )\n",
    "            for start_idx in range(\n",
    "                1, monthly_returns.shape[0] - monthly_returns.index.get_loc(start_date)\n",
    "            )\n",
    "        ],\n",
    "        index=B_returns.loc[start_date:].index,\n",
    "    )\n",
    "    .to_frame()\n",
    "    .rename({0: \"returns\"}, axis=1)\n",
    ")\n",
    "B_risk_parity_returns"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 14,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Risk-Parity with Model Selection B: \n",
      "Annualized Return: 0.0061803207332966625\n",
      "Annualized Volatility: 0.04209334277303941\n",
      "Annualized Sharpe Ratio: 0.14682418468449907\n",
      "time: 1.27 ms\n"
     ]
    },
    {
     "data": {
      "application/javascript": [
       "\n",
       "            setTimeout(function() {\n",
       "                var nbb_cell_id = 14;\n",
       "                var nbb_unformatted_code = \"print(f\\\"Risk-Parity with Model Selection B: \\\")\\nprint(f\\\"Annualized Return:\\\", annualized_return(B_risk_parity_returns.values))\\nprint(f\\\"Annualized Volatility:\\\", annualized_volatility(B_risk_parity_returns.values))\\nprint(f\\\"Annualized Sharpe Ratio:\\\", sharpe_ratio(B_risk_parity_returns.values))\";\n",
       "                var nbb_formatted_code = \"print(f\\\"Risk-Parity with Model Selection B: \\\")\\nprint(f\\\"Annualized Return:\\\", annualized_return(B_risk_parity_returns.values))\\nprint(f\\\"Annualized Volatility:\\\", annualized_volatility(B_risk_parity_returns.values))\\nprint(f\\\"Annualized Sharpe Ratio:\\\", sharpe_ratio(B_risk_parity_returns.values))\";\n",
       "                var nbb_cells = Jupyter.notebook.get_cells();\n",
       "                for (var i = 0; i < nbb_cells.length; ++i) {\n",
       "                    if (nbb_cells[i].input_prompt_number == nbb_cell_id) {\n",
       "                        if (nbb_cells[i].get_text() == nbb_unformatted_code) {\n",
       "                             nbb_cells[i].set_text(nbb_formatted_code);\n",
       "                        }\n",
       "                        break;\n",
       "                    }\n",
       "                }\n",
       "            }, 500);\n",
       "            "
      ],
      "text/plain": [
       "<IPython.core.display.Javascript object>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "print(f\"Risk-Parity with Model Selection B: \")\n",
    "print(f\"Annualized Return:\", annualized_return(B_risk_parity_returns.values))\n",
    "print(f\"Annualized Volatility:\", annualized_volatility(B_risk_parity_returns.values))\n",
    "print(f\"Annualized Sharpe Ratio:\", sharpe_ratio(B_risk_parity_returns.values))"
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Python 3",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.8.5"
  },
  "latex_envs": {
   "LaTeX_envs_menu_present": true,
   "autoclose": false,
   "autocomplete": true,
   "bibliofile": "biblio.bib",
   "cite_by": "apalike",
   "current_citInitial": 1,
   "eqLabelWithNumbers": true,
   "eqNumInitial": 1,
   "hotkeys": {
    "equation": "Ctrl-E",
    "itemize": "Ctrl-I"
   },
   "labels_anchors": false,
   "latex_user_defs": false,
   "report_style_numbering": false,
   "user_envs_cfg": false
  }
 },
 "nbformat": 4,
 "nbformat_minor": 4
}
